﻿# -*- coding: utf-8 -*-


#カーソルのクリック位置を変更

#上位パートの変換に対応（2010.02.25）
#モード5と6追加


#カーソルのクリック位置を変更してくれるスクリプトです。

#モード
#1.指定位置へ変更・・・・・テキストボックスの値を変更してからこのモードで「ok」を押すとクリック位置が指定した座標へ変更されます

#2.最初に選択した頂点の位置へ変更・・・・・ポリゴンメッシュ選択状態でこのモードで「ok」を押すと最初に選択した頂点の位置へクリック位置が変更されます
#ポリゴンメッシュ選択状態で、編集モードに入っており、頂点選択モードで頂点が一つ以上選択されている必要があります

#3.最後に選択に追加した頂点の位置へ変更・・・・・ポリゴンメッシュ選択状態でこのモードで「ok」を押すと最後に選択に追加した頂点の位置へクリック位置が変更されます
#ポリゴンメッシュ選択状態で編集モードに入っており、頂点選択モードで頂点が一つ以上選択されている必要があります

#4.球の中心位置へ変更・・・・球を選択してる状態でこのモードを選択して「ok」を押すとクリック位置が球の中心位置に変更されます
#球を選択している必要があります

#5．選択頂点の平均座標へ変更

#6．選択頂点を囲むバウンディングボックスの中心へ変更

#7.現在のクリック位置に球を作成（パートの場合は?）

#shade13に対応



def return_henkan_pos(pos,mat):
  #posをmatで変換した座標（タプル）を返す
  tempx=pos[0]
  tempy=pos[1]
  tempz=pos[2]
  x1=mat[0][0]*tempx+mat[1][0]*tempy+mat[2][0]*tempz+mat[3][0]*1
  y1=mat[0][1]*tempx+mat[1][1]*tempy+mat[2][1]*tempz+mat[3][1]*1
  z1=mat[0][2]*tempx+mat[1][2]*tempy+mat[2][2]*tempz+mat[3][2]*1
  return [x1,y1,z1]




def sort_point_by_active_order(pointlist):
  #頂点の選択番号(active_order)順にリストの頂点番号をソートして頂点リストを返す
  
  #ソート
  templist=[]
  for i in pointlist:
    templist.append(i)
  newlist=[]
  while(len(newlist)<len(pointlist)):
    minnumber=0 #リストのminnumber目の頂点の選択番号が最小値
    for i in range(1,len(templist)):
      if xshade.scene().active_shape().vertex(templist[i]).active_order<xshade.scene().active_shape().vertex(templist[minnumber]).active_order:
        minnumber=i
    newlist.append(templist[minnumber])
    templist.remove(templist[minnumber]) 

  return newlist       




#ここに初期値

renzoku=1
mode=0#0の場合指定位置へ変更、1の場合最初に選択した頂点の位置へ　2の場合最後に選択に追加した頂点の位置へ　3の場合球の中心位置へ
cursorpos=xshade.scene().cursor_position

while(renzoku==1):

  cursorpos=xshade.scene().cursor_position
  xtemp=cursorpos[0]
  ytemp=cursorpos[1]
  ztemp=cursorpos[2]


  #ダイアログ表示
  dialog=xshade.create_dialog()
  dialog.begin_group('位置')
  dialog.begin_box(False)
  idx1=dialog.append_float('x')
  idx2=dialog.append_float('y')
  idx3=dialog.append_float('z')
  dialog.end_box()
  dialog.end_group()

  idx4=dialog.append_radio_button('モード/指定位置へ変更/最初に選択した頂点位置へ変更（ポリゴンメッシュ選択時のみ）/最後に選択に追加した頂点位置へ移動（ポリゴンメッシュ選択時のみ）/球の中心位置へ移動（球選択時のみ）/選択頂点群の平均座標へ移動（ポリゴンメッシュ選択時のみ）/選択頂点を囲むバウンディングボックスの中心へ移動（ポリゴンメッシュ選択時のみ）')
  dialog.set_value(idx1,xtemp)
  dialog.set_value(idx2,ytemp)
  dialog.set_value(idx3,ztemp)
  dialog.set_value(idx4,mode)

  xshade.idle(120)
  xshade.scene().update_figure_window()
  kekka=dialog.ask('カーソルのクリック位置を変更')
  if kekka==False:
    renzoku=0

  if kekka==True:
    xtemp=dialog.get_value(idx1)
    ytemp=dialog.get_value(idx2)
    ztemp=dialog.get_value(idx3)
    mode=dialog.get_value(idx4)

    if mode==0:
      xshade.scene().cursor_position=[xtemp,ytemp,ztemp]

    if mode==1:
      if xshade.scene().active_shape().type==7 and xshade.scene().selection_mode==2 and xshade.scene().is_modify_mode==True:
        activeplist=[]
        for i in range(xshade.scene().active_shape().total_number_of_control_points):
          if xshade.scene().active_shape().vertex(i).active==True:
            activeplist.append(i)

        if len(activeplist)>0:
          activeplist=sort_point_by_active_order(activeplist)
          tpoint=activeplist[0]
#          xshade.scene().cursor_position=xshade.scene().active_shape().vertex(tpoint).position
          tempos=xshade.scene().active_shape().vertex(tpoint).position
          tmat=xshade.scene().active_shape().local_to_world_matrix
          tempos=return_henkan_pos(tempos,tmat)
          xshade.scene().cursor_position=tempos


    if mode==2:
      if xshade.scene().active_shape().type==7 and xshade.scene().selection_mode==2 and xshade.scene().is_modify_mode==True:
        activeplist=[]
        for i in range(xshade.scene().active_shape().total_number_of_control_points):
          if xshade.scene().active_shape().vertex(i).active==True:
            activeplist.append(i)

        if len(activeplist)>0:
          activeplist=sort_point_by_active_order(activeplist)
          tpoint=activeplist[len(activeplist)-1]
          tempos=xshade.scene().active_shape().vertex(tpoint).position
          tmat=xshade.scene().active_shape().local_to_world_matrix
          tempos=return_henkan_pos(tempos,tmat)
          xshade.scene().cursor_position=tempos

#          xshade.scene().cursor_position=xshade.scene().active_shape().vertex(tpoint).position

    if mode==3:
      if xshade.scene().active_shape().type==5:
        xshade.scene().cursor_position=xshade.scene().active_shape().center



    if mode==4:
      if xshade.scene().selection_mode!=2:xshade.scene().selection_mode=2
      if xshade.scene().active_shape().type==7 and xshade.scene().selection_mode==2 and xshade.scene().is_modify_mode==True:
        activeplist=[]
        for i in range(xshade.scene().active_shape().total_number_of_control_points):
          if xshade.scene().active_shape().vertex(i).active==True:
            activeplist.append(i)

        if len(activeplist)>0:
          activeplist=sort_point_by_active_order(activeplist)
          sum=[0,0,0]
          wari=len(activeplist)
          for i in activeplist:
            tempos=xshade.scene().active_shape().vertex(i).position
            sum=[sum[0]+tempos[0],sum[1]+tempos[1],sum[2]+tempos[2]]
          sum=[sum[0]/wari,sum[1]/wari,sum[2]/wari]
          tmat=xshade.scene().active_shape().local_to_world_matrix
          tempos=return_henkan_pos(sum,tmat)
          xshade.scene().cursor_position=tempos


    if mode==5:
      if xshade.scene().selection_mode!=2:xshade.scene().selection_mode=2
      if xshade.scene().active_shape().type==7 and xshade.scene().selection_mode==2 and xshade.scene().is_modify_mode==True:
        activeplist=[]
        for i in range(xshade.scene().active_shape().total_number_of_control_points):
          if xshade.scene().active_shape().vertex(i).active==True:
            activeplist.append(i)

        if len(activeplist)>0:
          activeplist=sort_point_by_active_order(activeplist)

          tempos=xshade.scene().active_shape().vertex(activeplist[0]).position
          minx=tempos[0]
          maxx=tempos[0]
          miny=tempos[1]
          maxy=tempos[1]
          minz=tempos[2]
          maxz=tempos[2]

          for i in activeplist:
            tempos2=xshade.scene().active_shape().vertex(i).position
            if minx>tempos2[0]:minx=tempos2[0]
            if maxx<tempos2[0]:maxx=tempos2[0]
            if miny>tempos2[1]:miny=tempos2[1]
            if maxy<tempos2[1]:maxy=tempos2[1]
            if minz>tempos2[2]:minz=tempos2[2]
            if maxz<tempos2[2]:maxz=tempos2[2]

          tempos=[(minx+maxx)/2,(miny+maxy)/2,(minz+maxz)/2]

          tmat=xshade.scene().active_shape().local_to_world_matrix
          tempos=return_henkan_pos(tempos,tmat)
          xshade.scene().cursor_position=tempos


